From 0592a2e6c5fc01bfaed71edd3988c8fddd22c5e1 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Wed, 9 May 2018 15:41:09 -0400
Subject: [PATCH 23/67] FIXME: try porting existing vectorization info to share
 with optimization records

---
 gcc/dumpfile.c              |  29 +-
 gcc/dumpfile.h              |   5 +
 gcc/optimization-records.cc |  81 ++--
 gcc/optimization-records.h  |  13 +
 gcc/tree-vect-data-refs.c   | 458 +++++++++++------------
 gcc/tree-vect-loop.c        | 891 +++++++++++++++++++++++---------------------
 gcc/tree-vect-slp.c         | 287 +++++++-------
 gcc/tree-vect-stmts.c       | 474 +++++++++++------------
 gcc/tree-vectorizer.c       |   4 +
 gcc/tree-vectorizer.h       |  22 ++
 10 files changed, 1202 insertions(+), 1062 deletions(-)

diff --git a/gcc/dumpfile.c b/gcc/dumpfile.c
index 7ae819a..20161f8 100644
--- a/gcc/dumpfile.c
+++ b/gcc/dumpfile.c
@@ -451,31 +451,36 @@ dump_printf (dump_flags_t dump_kind, const char *format, ...)
     }
 }
 
-/* Similar to dump_printf, except source location is also printed.  */
-
+/* FIXME.  */
 void
-dump_printf_loc (dump_flags_t dump_kind, source_location loc,
-		 const char *format, ...)
+dump_printf_loc_va (dump_flags_t dump_kind, source_location loc,
+		    const char *format, va_list *ap)
 {
   if (dump_file && (dump_kind & pflags))
     {
-      va_list ap;
       dump_loc (dump_kind, dump_file, loc);
-      va_start (ap, format);
-      vfprintf (dump_file, format, ap);
-      va_end (ap);
+      vfprintf (dump_file, format, *ap);
     }
 
   if (alt_dump_file && (dump_kind & alt_flags))
     {
-      va_list ap;
       dump_loc (dump_kind, alt_dump_file, loc);
-      va_start (ap, format);
-      vfprintf (alt_dump_file, format, ap);
-      va_end (ap);
+      vfprintf (alt_dump_file, format, *ap);
     }
 }
 
+/* Similar to dump_printf, except source location is also printed.  */
+
+void
+dump_printf_loc (dump_flags_t dump_kind, source_location loc,
+		 const char *format, ...)
+{
+  va_list ap;
+  va_start (ap, format);
+  dump_printf_loc_va (dump_kind, loc, format, &ap);
+  va_end (ap);
+}
+
 /* Output VALUE in decimal to appropriate dump streams.  */
 
 template<unsigned int N, typename C>
diff --git a/gcc/dumpfile.h b/gcc/dumpfile.h
index cb4e66a..044c3ad 100644
--- a/gcc/dumpfile.h
+++ b/gcc/dumpfile.h
@@ -165,6 +165,8 @@ extern const char *dump_flag_name (int);
 extern void dump_printf (dump_flags_t, const char *, ...) ATTRIBUTE_PRINTF_2;
 extern void dump_printf_loc (dump_flags_t, source_location,
                              const char *, ...) ATTRIBUTE_PRINTF_3;
+extern void dump_printf_loc_va (dump_flags_t, source_location,
+				const char *, va_list *) ATTRIBUTE_PRINTF (3, 0);
 extern void dump_function (int phase, tree fn);
 extern void dump_basic_block (int, basic_block, int);
 extern void dump_generic_expr_loc (int, source_location, int, tree);
@@ -199,6 +201,9 @@ dump_enabled_p (void)
   return (dump_file || alt_dump_file);
 }
 
+// FIXME:
+extern bool thing_enabled_p ();
+
 extern void fancy_dump_start ();
 extern void fancy_dump_finish ();
 
diff --git a/gcc/optimization-records.cc b/gcc/optimization-records.cc
index c020f85..dc47549 100644
--- a/gcc/optimization-records.cc
+++ b/gcc/optimization-records.cc
@@ -130,7 +130,15 @@ opt_record_kind_to_string (enum opt_record_kind kind)
 
 /* FIXME.  */
 
-static void
+bool
+optimization_record_enabled_p ()
+{
+  return records != NULL;
+}
+
+/* FIXME.  */
+
+void
 maybe_record_optimization_va (enum opt_record_kind kind,
 			      gimple *stmt,
 			      const char *fmt, va_list *ap)
@@ -139,13 +147,26 @@ maybe_record_optimization_va (enum opt_record_kind kind,
   if (!records)
     return;
 
+  /* Formatted output.  */
+  char *msg;
+  vasprintf (&msg, fmt, *ap);
+
   json::object *obj = new json::object ();
 
   obj->set ("kind", new json::string (opt_record_kind_to_string (kind)));
+  obj->set ("message", new json::string (msg));
 
   if (current_pass)
     obj->set ("pass", new json::string (current_pass->name));
-  location_t loc = gimple_location (stmt);
+
+  location_t loc = UNKNOWN_LOCATION;
+  if (stmt)
+    {
+      loc = gimple_location (stmt);
+      if (stmt->bb->count.initialized_p ())
+	obj->set ("count", profile_count_to_json (stmt->bb->count));
+    }
+
   if (loc != UNKNOWN_LOCATION)
     {
       // TOOD: record the location (just caret for now)
@@ -159,16 +180,42 @@ maybe_record_optimization_va (enum opt_record_kind kind,
       obj->set ("function", new json::string (fnname));
     }
 
-  /* Formatted output.  */
-  char *msg;
-  vasprintf (&msg, fmt, *ap);
-  obj->set ("message", new json::string (msg));
+  records->append (obj);
+
+  // Also send it through the diagnostics subsystem:
+  if (1)
+    {
+      if (current_pass)
+	remark (loc, 0, "%s [pass=%qs]", msg, current_pass->name);
+      else
+	remark (loc, 0, "%s", msg);
+    }
+
   free (msg);
+}
 
-  if (stmt->bb->count.initialized_p ())
-    obj->set ("count", profile_count_to_json (stmt->bb->count));
+/* FIXME.  */
 
-  records->append (obj);
+void
+maybe_record_optimization_va (enum opt_record_kind kind,
+			      struct loop *loop,
+			      const char *fmt, va_list *ap)
+{
+  gimple *stmt = get_loop_exit_condition (loop);
+  if (!stmt)
+    {
+      gimple_stmt_iterator si;
+      for (si = gsi_start_bb (loop->header); !gsi_end_p (si); gsi_next (&si))
+	{
+	  if (LOCATION_LOCUS (gimple_location (stmt)) > BUILTINS_LOCATION)
+	    {
+	      stmt = gsi_stmt (si);
+	      break;
+	    }
+	}
+    }
+
+  maybe_record_optimization_va (kind, stmt, fmt, ap);
 }
 
 /* FIXME.  */
@@ -199,22 +246,8 @@ maybe_record_optimization (enum opt_record_kind kind,
   if (!records)
     return;
 
-  gimple *stmt = get_loop_exit_condition (loop);
-  if (!stmt)
-    {
-      gimple_stmt_iterator si;
-      for (si = gsi_start_bb (loop->header); !gsi_end_p (si); gsi_next (&si))
-	{
-	  if (LOCATION_LOCUS (gimple_location (stmt)) > BUILTINS_LOCATION)
-	    {
-	      stmt = gsi_stmt (si);
-	      break;
-	    }
-	}
-    }
-
   va_list ap;
   va_start (ap, fmt);
-  maybe_record_optimization_va (kind, stmt, fmt, &ap);
+  maybe_record_optimization_va (kind, loop, fmt, &ap);
   va_end (ap);
 }
diff --git a/gcc/optimization-records.h b/gcc/optimization-records.h
index 8513781..b82a17f 100644
--- a/gcc/optimization-records.h
+++ b/gcc/optimization-records.h
@@ -37,6 +37,19 @@ enum opt_record_kind
 
 extern const char *opt_record_kind_to_string (enum opt_record_kind kind);
 
+// FIXME: maybe make this inline?
+extern bool optimization_record_enabled_p ();
+
+extern void maybe_record_optimization_va (enum opt_record_kind kind,
+					  gimple *stmt,
+					  const char *fmt, va_list *ap)
+  ATTRIBUTE_PRINTF (3, 0);
+
+extern void maybe_record_optimization_va (enum opt_record_kind kind,
+					  struct loop *,
+					  const char *fmt, va_list *ap)
+  ATTRIBUTE_PRINTF (3, 0);
+
 // FIXME: param name?  i18n?
 extern void maybe_record_optimization (enum opt_record_kind kind,
 				       gimple *stmt,
